//IOSVCUCB JOB (SYS),'ADD UCBSCAN TO CVT  ',                            00000100
//             CLASS=A,MSGCLASS=X,NOTIFY=&SYSUID                        00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* Source: H390-MVS group at Yahoo; posted 04/27/2016                * 00000500
//*                                                                   * 00000600
//* The author of this chose to remain anonymous, but the files were  * 00000700
//* posted by somitcw@yahoo.com.                                      * 00000800
//*                                                                   * 00000900
//* The problem: Subsequent to MVS 3.8j a routine was included in the * 00001000
//* operating system to scan the UCB table (control blocks for physi- * 00001100
//* cal devices). This routine is required for some programs on the   * 00001200
//* CBT tape, as well as some IBM programs, such as TRSMAIN. The      * 00001300
//* usual solution is to comment out calls to the OS resident routine * 00001400
//* and code a substitute routine, an approach I used for several of  * 00001500
//* the programs from CBT distributed from my CBT pages. That works   * 00001600
//* fine when you have the source.                                    * 00001700
//*                                                                   * 00001800
//* This solution: A UCB scan routine is coded in assembler, and is   * 00001900
//* installed in SYS1.LPALIB, which is then loaded into the Link Pack * 00002000
//* Area (during IPL when CLPA is specified). A second assembler      * 00002100
//* program is run after IPL to place the address of the scan routine * 00002200
//* into the CVT at X'434', which is the address that contains the    * 00002300
//* routine in later MVS operating systems.                           * 00002400
//* ***************************************************************** * 00002500
//*                                                                     00002600
//* ***************************************************************** * 00002700
//* Step: IOSVCUCB: assemble/link scan routine into SYS1.LPALIB       * 00002800
//* ***************************************************************** * 00002900
//*                                                                     00003000
//IOSVCUCB EXEC ASMFCL,                                                 00003100
//             PARM.ASM=(RENT,NOTERM,OBJECT,NODECK),                    00003200
//             PARM.LKED=(REFR,RENT,NOTERM,XREF,LIST,NCAL)              00003300
//ASM.SYSLIB  DD                                                        00003400
//        DD  DISP=SHR,DSN=SYS1.AMODGEN                                 00003500
PASS     TITLE 'IOSVSUCB - - Simulates MVS/SP UCBSCAN for TRSMAIN'      00003600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00003700
*                                                                       00003800
* This program is for testing.  Don't expect much.                      00003900
* Re-write as needed.                                                   00004000
*                                                                       00004100
* This program tries to partially perform an MVS 3.8j equalivant of     00004200
* the same program name in MVS/SP and later systems that is at          00004300
* CVT+X'434'                                                            00004400
* CVTUCBSC "V(IOSVSUCB)" - Address of UCB scan service.                 00004500
*                                                                       00004600
* Created 2016-04-20                                                    00004700
*                                                                       00004800
* Written by: I ain't saying                                            00004900
*                                                                       00005000
* I.P. Status: Abandonware                                              00005100
*                                                                       00005200
* Input:                                                                00005300
*                                                                       00005400
* R15 = entry address                                                   00005500
* R1 = pointer to PARM list                                             00005600
* PARM list is three words with:                                        00005700
* Word 1 of 3 is Workarea pointer                                       00005800
* Word 2 of 3 is Device class bits requested:                           00005900
* - ALL  X'00'                                                          00006000
* - TAPE X'80'                                                          00006100
* - COMM X'40'                                                          00006200
* - CTC  X'41'                                                          00006300
* - DASD X'20'                                                          00006400
* - DISP X'10'                                                          00006500
* - UREC X'08'                                                          00006600
* - CHAR X'04'                                                          00006700
* - Reserved X'02'                                                      00006800
* - Reserved X'01'                                                      00006900
* - UCB + X'12' is UCBDVCLS, same as UCBTBYT3                           00007000
* Word 3 of 3 is address to return the found UCB address in             00007100
*                                                                       00007200
* Return code 0 reason code any if a UCB address found                  00007300
* Return code 4 reason code 1 if no UCB address found,                  00007400
*     as in off the end of the UCB address table.                       00007500
*                                                                       00007600
*  Return code is returned in register 15.                              00007700
*  Reason code is returned in register 0.                               00007800
*                                                                       00007900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00008000
*                                                                       00008100
         SPACE 3                                                        00008200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00008300
*                                                                       00008400
* Register equates                                                      00008500
*                                                                       00008600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00008700
         SPACE 1                                                        00008800
         MACRO                                                          00008900
         REGS  ,                  Generate register equates             00009000
         LCLA  &R                 Register number                       00009100
&R       SETA  0                  Initialize register number to zero    00009200
.AGAIN   ANOP                                                           00009300
R&R      EQU   &R                 Register equate for register &R       00009400
&R       SETA  &R+1                                                     00009500
         AIF   (&R LT 16).AGAIN                                         00009600
         MEND                                                           00009700
         EJECT                                                          00009800
*                                                                       00009900
         PRINT ON,GEN,DATA        Show all                              00010000
         REGS  ,                  Generate register equates R0-R15      00010100
IOSVSUCB CSECT ,                                                        00010200
         USING *,R15              Set temporary base register           00010300
         SAVE  (14,12),,'IOSVSUCB.&SYSDATE..&SYSTIME' Save registers    00010400
         DROP  R15                DROP the temporary base register      00010500
         LR    R12,R15            LOAD this program's base register     00010600
         USING IOSVSUCB,R12       Give the assembler the new base       00010700
* Really weird.  This program doesn't call anything so                  00010800
* does not create a new save area which avoids a GETMAIN/FREEMAIN       00010900
* If it needed a save area it could use part of the work area passed    00011000
         LM    R3,R5,0(R1)        Load input PARM addresses             00011100
* R3 points to a work area                                              00011200
* R4 points to device class                                             00011300
* R5 points to area to return a UCB address                             00011400
* Not a real program so no checking is done for three PARMs given       00011500
         USING WORK,R3            Give assembler save and work area reg 00011600
         ICM   R6,B'1111',SAVEILK2  See if a previous call              00011700
         BZ    FIRST              First call, go CVTLNK2 addr.          00011800
* R6 has the CVTILJK2 table entry address                               00011900
FINDNEXT DS    0H                                                       00012000
         LA    R6,2(,R6)          Get addr.of next look-up table entry  00012100
NEXT     DS    0H                                                       00012200
         LH    R8,0(,R6)          load 16-bit UCB address               00012300
         N     R8,X000FFFF        Apply UCB address mask                00012400
* N allows a BZ or BNZ, there is no BO                                  00012500
         BZ    FINDNEXT            Address is 0 so not a UCB, go bump   00012600
         C     R8,X000FFFF        Apply UCB address to X'0000FFFF'      00012700
         BE    NOMORE              Is X'FFFF', so at end, go exit RC 4  00012800
         CLI   0(R4),X'00'        See if all device clases requested    00012900
         BE    EOP0                 Is ALL, so UCB found, Ret.code 0    00013000
         CLC   18(1,R8),0(R4)     See if device class matches request   00013100
* UCBDVCLS is the same as UCBTBYT3, Device class bits                   00013200
         BE    EOP0                 Found, return with Ret.code 0       00013300
         BNE   FINDNEXT             Unwanted UCB, go check for the next 00013400
*                                                                       00013500
FIRST    DS    0H                                                       00013600
         L     R7,16              Load the address of the CVT           00013700
* 000028 CVTILK2 DC V(IECILK2)                                          00013800
*    Address of the UCB halfword address list portion                   00013900
*    of the UCB lookup table                                            00014000
* It's just a list of halfwords with each halfword pointing             00014100
* to a UCB.  That is why UCBs are restricted to low memory.             00014200
* Address over 64KB need more than a halfword.                          00014300
         L     R6,X'28'(,R7)      Load address of CVTILK2 UCB lookup    00014400
         B     NEXT               Go process                            00014500
*                                                                       00014600
NOMORE   DS    0H                                                       00014700
* Do not alter previous returned UCB address                            00014800
         XC    WORK(4),WORK       Clear work area used, not 100 bytes   00014900
         LA    R15,4              Set return code to four, no more UCBs 00015000
         B     EOP                Go to return to caller                00015100
EOP0     DS    0H                                                       00015200
         ST    R8,0(,R5)          Return the UCB address for caller     00015300
         SLR   R15,R15            Set return code to zero, a UCB found  00015400
         ST    R6,SAVEILK2        Save location for CVTILK2 table entry 00015500
EOP      DS    0H                                                       00015600
         L     R14,12(,R13)       Restore callers return address        00015700
         LA    R0,1               Reason code to 1, ignored for RC=0    00015800
         LM    R1,R12,24(R13)     Restore other caller's registers      00015900
         DROP  R3,R12             Drop work area and base registers     00016000
         BR    R14                Return to caller                      00016100
         EJECT ,                                                        00016200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00016300
*                                                                       00016400
*      Constants                                                        00016500
*                                                                       00016600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00016700
*                                                                       00016800
X000FFFF DC   F'65535'            X'0000FFFF' end of CVTLNK2 indicator  00016900
*                                                                       00017000
         LTORG ,                  In case someone uses literals         00017100
         EJECT ,                                                        00017200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00017300
*                                                                       00017400
*      DSECTs                                                           00017500
*                                                                       00017600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00017700
*                                                                       00017800
WORK     DSECT ,                                                        00017900
SAVEILK2 DS    F                  Save old CVTILK2 table entry address  00018000
         DS    XL96               Unused work area space                00018100
* only the first four bytes are used with the other 96 bytes ignored    00018200
*                                                                       00018300
         EJECT                                                          00018400
         PRINT ON,GEN,DATA                                              00018500
         CVT   DSECT=YES,LIST=YES,PREFIX=NO                             00018600
         EJECT                                                          00018700
*                                                                       00018800
         PRINT ON,GEN,DATA                                              00018900
UCB      DSECT ,                                                        00019000
         IEFUCBOB LIST=YES,PREFIX=NO                                    00019100
*                                                                       00019200
         END   ,                  The end of the program                00019300
//LKED.SYSLMOD DD DISP=SHR,DSN=SYS1.LPALIB                              00019400
 NAME IOSVSUCB(R)                                                       00019500
/*                                                                      00019600
//*                                                                     00019700
//* ***************************************************************** * 00019800
//* Step: UCBSCANZ: assemble/link program to zap CVT+X'434' into      * 00019900
//* SYS2.LINKLIB                                                      * 00020000
//* ***************************************************************** * 00020100
//*                                                                     00020200
//UCBSCANZ EXEC ASMFCL,                                                 00020300
//             PARM.ASM=(RENT,NOTERM,OBJECT,NODECK),                    00020400
//             PARM.LKED='AC=1,REFR,RENT,NOTERM,XREF,LIST,NCAL'         00020500
//ASM.SYSLIB  DD                                                        00020600
//        DD  DISP=SHR,DSN=SYS1.AMODGEN                                 00020700
PASS     TITLE 'USCANZAP - - Puts address of IOSVSUCB in CVT+X''434'''  00020800
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00020900
*                                                                       00021000
* This program find the entry point for IOSVSUCB in the LPA and         00021100
* stores the address in the CVT+X'434'                                  00021200
*                                                                       00021300
* For MVS/SP and newer:                                                 00021400
* 000434 CVTUCBSC DC "V(USCANZAP)" - Address of UCB scan service.       00021500
*                                                                       00021600
* This program overlays MVS 3.8j                                        00021700
*                                                                       00021800
* 000434 CVTRV628 DC A(0) - RESERVED  (MDC307) @Z30AQ9A                 00021900
*                                                                       00022000
* Created 2016-04-20                                                    00022100
*                                                                       00022200
* Input:                                                                00022300
*                                                                       00022400
* R15 = entry address                                                   00022500
*                                                                       00022600
* Return code 0 if address stored                                       00022700
* System ABEND S806-4 if IOSVSUCB not in LPA                            00022800
* Weird stuff if IOSVSUCB is in LinkList or JOBLIB/STEPLIB              00022900
* ( won't happen ) WTO and user ABEND U1234 if LOAD EP=IOSVSUCB fails   00023000
* System ABEND ? S047 ? if not APF authorized.                          00023100
*                                                                       00023200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00023300
*                                                                       00023400
         SPACE 3                                                        00023500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00023600
*                                                                       00023700
* Register equates                                                      00023800
*                                                                       00023900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00024000
         SPACE 1                                                        00024100
         MACRO                                                          00024200
         REGS  ,                  Generate register equates             00024300
         LCLA  &R                 Register number                       00024400
&R       SETA  0                  Initialize register number to zero    00024500
.AGAIN   ANOP                                                           00024600
R&R      EQU   &R                 Register equate for register &R       00024700
&R       SETA  &R+1                                                     00024800
         AIF   (&R LT 16).AGAIN                                         00024900
         MEND                                                           00025000
         EJECT                                                          00025100
*                                                                       00025200
         PRINT ON,GEN,DATA        Show all                              00025300
         REGS  ,                  Generate register equates R0-R15      00025400
USCANZAP CSECT ,                                                        00025500
         USING *,R15              Set temporary base register           00025600
         SAVE  (14,12),,'USCANZAP.&SYSDATE..&SYSTIME' Save registers    00025700
         DROP  R15                DROP the temporary base register      00025800
         LR    R12,R15            LOAD this program's base register     00025900
         USING USCANZAP,R12       Give the assembler the new base       00026000
         LOAD  EP=IOSVSUCB        Find LPA address of IOSVSUCB          00026100
         LTR   R15,R15            Check return code                     00026200
         BNZ   ABEND1               Not zero, load failed, go ABEND     00026300
         LR    R3,R0              Save address of IOSVSUCB              00026400
         L     R4,16              Load address of the CVT               00026500
         MODESET KEY=ZERO         Switch to key zero                    00026600
         ST    R3,X'434'(,R4)     Put IOSVSUCB address in CVT+X'434'    00026700
         MODESET KEY=NZERO        Switch to user key                    00026800
EOP      DS    0H                                                       00026900
         RETURN (14,12),RC=0      Return to caller                      00027000
*                                                                       00027100
ABEND1   DS    0H                                                       00027200
         WTO   'USCANZAP is not APF authorized so is ABENDing'          00027300
         ABEND 1234               ABEND with no dump                    00027400
         DC    H'0'               Insure an ABEND                       00027500
         DROP  R12                Drop base                             00027600
         EJECT ,                                                        00027700
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00027800
*                                                                       00027900
*      Constants                                                        00028000
*                                                                       00028100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00028200
*                                                                       00028300
         LTORG ,                  In case someone uses literals         00028400
         EJECT ,                                                        00028500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00028600
*                                                                       00028700
*      DSECTs                                                           00028800
*                                                                       00028900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00029000
*                                                                       00029100
         EJECT                                                          00029200
         PRINT ON,GEN,DATA                                              00029300
         CVT   DSECT=YES,LIST=YES,PREFIX=NO                             00029400
*                                                                       00029500
         END   ,                  The end of the program                00029600
//LKED.SYSLMOD DD DISP=SHR,DSN=SYS2.LINKLIB                             00029700
 NAME UCBSCANZ(R)                                                       00029800
/*                                                                      00029900
//*                                                                     00030000
//* ***************************************************************** * 00030100
//* Step: UCBSCANT: assemble/link program to verify routine can be    * 00030200
//* found from CBT+x'434' into SYS2.LINKLIB                           * 00030300
//* ***************************************************************** * 00030400
//*                                                                     00030500
//UCBSCANT EXEC ASMFCL,                                                 00030600
//             PARM.ASM=(RENT,NOTERM,OBJECT,NODECK),                    00030700
//             PARM.LKED=(REFR,RENT,NOTERM,XREF,LIST,NCAL)              00030800
//ASM.SYSLIB  DD                                                        00030900
//        DD  DISP=SHR,DSN=SYS1.AMODGEN                                 00031000
PASS     TITLE 'UCBSCAN - - List DISK UCBs'                             00031100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00031200
*                                                                       00031300
* This program is for testing stuff.                                    00031400
* Re-write as needed                                                    00031500
*                                                                       00031600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00031700
*                                                                       00031800
         SPACE 3                                                        00031900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00032000
*                                                                       00032100
* Register equates                                                      00032200
*                                                                       00032300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00032400
         SPACE 1                                                        00032500
         MACRO                                                          00032600
         REGS  ,                  Generate register equates             00032700
         LCLA  &R                 Register number                       00032800
&R       SETA  0                  Initialize register number to zero    00032900
.AGAIN   ANOP                                                           00033000
R&R      EQU   &R                 Register equate for register &R       00033100
&R       SETA  &R+1                                                     00033200
         AIF   (&R LT 16).AGAIN                                         00033300
         MEND                                                           00033400
         EJECT                                                          00033500
*                                                                       00033600
         PRINT ON,GEN,DATA        Show all                              00033700
         REGS  ,                  Generate register equates R0-R15      00033800
UCBSCAN  CSECT ,                                                        00033900
         USING *,R15              Set temporary base register           00034000
         SAVE  (14,12),,'UCBSCAN.&SYSDATE..&SYSTIME' Save registers     00034100
         DROP  R15                DROP the temporary base register      00034200
         LR    R12,R15            Load this program's base register     00034300
         USING UCBSCAN,R12       Give the assembler the new base        00034400
         LR    R2,R1             Save the incoming PARM list address    00034500
         GETMAIN RU,LV=WORKLEN    Get save and work area                00034600
         XC    0(ZEROLEN,R1),0(R1)  Clear first part of save/work area  00034700
         ST    R1,8(,R13)         Chain old and new save areas          00034800
         ST    R13,4(,R1)         Chain old and new save areas          00034900
         LR    R13,R1             Chain old and new save areas          00035000
         USING WORK,R13           Give assembler save and work area reg 00035100
         LTR   R2,R2              Is there a PARM list address? (weird) 00035200
         BZ    NOPARM              No PARM list addr, go default to ALL 00035300
         ICM   R2,B'1111',0(R2)   Is there a PARM address?              00035400
         BZ    NOPARM              No PARM addr, go default to ALL      00035500
         LA    R1,DCTABLE         Load dev.class tableaddr to search    00035600
LOOP     DS    0H                                                       00035700
         CLC   2(3,R2),0(R1)      See if PARM matched table entry       00035800
         BE    FOUND                If a match, go process              00035900
         CLC   0(4,R1),CTC        See if end of the table               00036000
         BE    NOPARM               Entry not found, set the default    00036100
         LA    R1,5(,R1)          Bump to next device class table entry 00036200
         B     LOOP               Go check next dev.class table entry   00036300
FOUND    DS    0H                                                       00036400
         MVC   DEVCLASS,4(R1)     Move found dev.class for UCB search   00036500
         B     OUTPARM            Go finish preparing for search        00036600
NOPARM   DS    0H                                                       00036700
         XC    DEVCLASS,DEVCLASS  Set device class to X'00' as in ALL   00036800
OUTPARM  DS    0H                                                       00036900
         LA    R1,WORKAREA        Load address of UCBSCAN work area     00037000
         ST    R1,PARM1           Store UCBSCAN work area in PARM list  00037100
         LA    R1,DEVCLASS        Load addr. of requested device class  00037200
         ST    R1,PARM2           Store dev.class DASD in PARM list     00037300
         LA    R1,UCBPTR          Load addr. for UCB addr. returned     00037400
         ST    R1,PARM3           Store UCB address loc. in PARM list   00037500
         OI    PARM3,X'80'        Set third word as end of PARM list    00037600
         MVC   SYSPRINT,DUMPRDCB  Initialize SYSPRINT DCB location      00037700
         OI    OCL,X'80'          Mark OPEN/CLOSE list as one DDNAME    00037800
         OPEN  (SYSPRINT,OUTPUT),MF=(E,OCL)  OPEN output print          00037900
         L     R11,16             Load address of CVT                   00038000
         L     R11,X'434'(,R11)   Load address of IOSVSUCB              00038100
* CVT+X'434' is                                                         00038200
* CVTUCBSC "V(IOSVSUCB)" - Address of UCB scan service.                 00038300
* Previously known as:                                                  00038400
* CVTRV628 DC A(0) - Reserved (MDC307) @Z30AQ9A                         00038500
*                                                                       00038600
LOOP2    DS    0H                                                       00038700
         LA    R1,PARMLIST        Load address of three word PARM list  00038800
         LR    R15,R11            Load address of IOSVSUCB              00038900
         BALR  R14,R15            CALL IOSVSUCB                         00039000
         LTR   R15,R15            See if return code is zero            00039100
         BNZ   EOP                  Not zero, go to end of program      00039200
* end of UCBs will be R15=4 and R0=1 for RC=4 and reason-code=1         00039300
         L     R1,UCBPTR          Load address of returned UCB          00039400
         MVI   PRINTREC,X'40'     Space out print area                  00039500
         MVC   PRINTREC+1(L'PRINTREC),PRINTREC  Space out print area    00039600
         MVC   CCCU,13(R1)        Move device number for print          00039700
         UNPK  DEVTYPE(9),16(5,R1)    Move device type for print        00039800
         MVI   DEVTYPE+8,X'40'    Blank garbage byte after dev.type     00039900
         TR    DEVTYPE(8),TRTABLE-240 Translate device type for print   00040000
         TM    3(R1),X'80'        See if OFFLINE                        00040100
         BZ    ITISOFF              Is OFFLINE, go to IT-IS-OFF         00040200
         MVC   ONOFF,ONLINE       Move CL7'ONLINE ' to print            00040300
         CLI   18(R1),X'20'       See if a DASD                         00040400
         BE    MVCVOL               Is DASD, move volser for TAPE&DASD  00040500
         CLI   18(R1),X'80'       See if a TAPE                         00040600
         BNE   PRINT                Not tape or disk, go print          00040700
MVCVOL   DS    0H                                                       00040800
         MVC   VOLSER,28(R1)      Move volume serial number to print    00040900
         B     PRINT              Go print a print line                 00041000
ITISOFF  DS    0H                                                       00041100
         MVC   ONOFF,OFFLINE      Move CL7'OFFLINE' to print            00041200
*        B     PRINT              Go print a print line                 00041300
PRINT    DS    0H                                                       00041400
         PUT   SYSPRINT,PRINTREC  Print an output line                  00041500
         B     LOOP2              Go back to get the next UCB address   00041600
*                                                                       00041700
EOP      DS    0H                                                       00041800
         CLOSE SYSPRINT,MF=(E,OCL)  Close print output file             00041900
         LR    R1,R13             Save work area address                00042000
         L     R13,4(,R1)         Restore the caller's save area addr.  00042100
         FREEMAIN RU,LV=WORKLEN,A=(1)  Free work and save area          00042200
         RETURN (14,12),RC=0      Return to caller                      00042300
         EJECT ,                                                        00042400
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00042500
*                                                                       00042600
*      Constants                                                        00042700
*                                                                       00042800
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00042900
*                                                                       00043000
DCTABLE  EQU  *                   Device class table                    00043100
DASD     DC   CL4'DASD',XL1'20'   Requesting device class DASD          00043200
ALL      DC   CL4'ALL ',XL1'00'   Requesting all device classes         00043300
TAPE     DC   CL4'TAPE',XL1'80'   Requesting device class TAPE          00043400
COMM     DC   CL4'COMM',XL1'40'   Requesting device class COMM          00043500
DISP     DC   CL4'DISP',XL1'10'   Requesting device class DISP          00043600
UREC     DC   CL4'UREC',XL1'08'   Requesting device class UREC          00043700
CHAR     DC   CL4'CHAR',XL1'04'   Requesting device class CHAR          00043800
CTC      DC   CL4'CTC ',XL1'41'   Requesting device class CTC           00043900
* CTC must stay at the end to also terminate the search                 00044000
*                                                                       00044100
ONLINE   DC    CL7'ONLINE'        A word for print                      00044200
OFFLINE  DC    CL7'OFFLINE'       A word for print                      00044300
*                                                                       00044400
         DS    0D                 Insure the following DCB is aligned   00044500
DUMPRDCB DCB  DDNAME=SYSPRINT,DSORG=PS,MACRF=PM,RECFM=FBA,LRECL=121     00044600
DUMPRLEN EQU  *-DUMPRDCB          Length of SYSPRINT DCB template       00044700
*                                                                       00044800
TRTABLE  DC    CL16'0123456789ABCDEF'  To translate BCD to display      00044900
*                                                                       00045000
         LTORG ,                  In case someone uses literals         00045100
         EJECT ,                                                        00045200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00045300
*                                                                       00045400
*      DSECTs                                                           00045500
*                                                                       00045600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   00045700
*                                                                       00045800
WORK     DSECT ,                                                        00045900
SAVEAREA DS    18F                Register save area                    00046000
*        OPEN  (SYSPRINT,OUTPUT),MF=L  OPEN/CLOSE list                  00046100
OCL      DS    D                  OPEN/CLOSE PARM list with extra word  00046200
WORKAREA DS    XL100              First UCBSCAN PARM                    00046300
ZEROLEN  EQU   *-SAVEAREA         Length of the save/work area to clear 00046400
* Next four lines must stay together                                    00046500
PARMLIST EQU   *,12               PARM list is the next three lines     00046600
PARM1    DS    F                  First UCBSCAN PARM, Addr. of WORKAREA 00046700
PARM2    DS    F                  Second UCBSCAN PARM, Addr. of X'20'   00046800
PARM3    DS    F                  Third UCBSCAN PARM, Addr. of UCBPTR   00046900
* Previous four lines must stay together                                00047000
UCBPTR   DS    F                  Will be UCB addr. returned by UCBSCAN 00047100
         DS    0D                 Insure the following DCBs are aligned 00047200
SYSPRINT DS    XL(DUMPRLEN)       Space for the print DCB               00047300
*                                                                       00047400
DEVCLASS DS    XL1                Device class to search for, 0 for all 00047500
*                                                                       00047600
PRINTREC DS    CL121              Space for printing device number      00047700
CCCU     EQU   PRINTREC+2,3       Device address for print              00047800
DEVTYPE  EQU   PRINTREC+6,8       Hex device type for print             00047900
ONOFF    EQU   PRINTREC+16,7      ONLINE or OFFLINE                     00048000
VOLSER   EQU   PRINTREC+25,6      Volume serial number                  00048100
WORKLEN  EQU   *-SAVEAREA         Length of the save and work areas     00048200
*                                                                       00048300
         EJECT                                                          00048400
         PRINT ON,GEN,DATA                                              00048500
         CVT   DSECT=YES,LIST=YES,PREFIX=NO                             00048600
*                                                                       00048700
         EJECT                                                          00048800
         PRINT ON,GEN,DATA                                              00048900
UCB      DSECT ,                                                        00049000
         IEFUCBOB LIST=YES,PREFIX=NO                                    00049100
*                                                                       00049200
         END   ,                  The end of the program                00049300
//LKED.SYSLMOD DD DISP=SHR,DSN=SYS2.LINKLIB                             00049400
 NAME UCBSCANT(R)                                                       00049500
/*                                                                      00049600
//*                                                                     00049700
//* ***************************************************************** * 00049800
//* Step: IEBUPDTE: create procedure in SYS2.PROCLIB to execute       * 00049900
//* program to ZAP address of IOSVSUCB in Link Pack Area into CVT     * 00050000
//* ***************************************************************** * 00050100
//*                                                                     00050200
//IEBUPDTE EXEC PGM=IEBUPDTE,REGION=1024K,PARM=NEW                      00050300
//SYSUT2   DD  DSN=SYS2.PROCLIB,DISP=OLD                                00050400
//SYSPRINT DD  SYSOUT=*                                                 00050500
//SYSIN    DD  DATA,DLM='><'                                            00050600
./ ADD NAME=IOSVSUCB,LIST=ALL                                           00050700
./ NUMBER NEW1=10,INCR=10                                               00050800
//IOSVSUCB PROC                                                         00050900
//* ***************************************************************** * 00051000
//* LOAD ADDRESS OF IOSVSUCB INTO CVT+X'434' (UCB SCAN ROUTINE)       * 00051100
//* ***************************************************************** * 00051200
//IOSVSUCB EXEC PGM=UCBSCANZ                                            00051300
./ ENDUP                                                                00051400
><                                                                      00051500
//                                                                      00051600
